"""A basic interface for Hspell"""

# This file is released under the terms of the GPL
# Copyright (C) Mooffie <mooffie@typo.co.il>

import cfg
import os
import string
import thread

class Hspell:

    def __init__(self, cmd=None):
	if not cmd:
	    cmd = cfg.hspell_command % cfg.hspell_a_args
	self.wr, self.rd = os.popen2(cmd)
	if self.rd.readline().find("Hspell") == -1:
	    raise SystemError, "I DON'T SEE HSPELL'S SIGNATURE! THIS IS NOT HSPELL!"
	self.tlock = thread.allocate_lock()

    # In multi-threaded applications, you should envelope check_word()
    # with lock() and unlock()
    def lock(self):
	self.tlock.acquire()

    def unlock(self):
	self.tlock.release()

    # See ispell's manual page for the protocol
    def check_word(self, word):
	self.wr.write(word + "\n")
	self.wr.flush()
	suggestions = []
	hint = ""
	wrong = 0
	while 1:
	    line = string.rstrip(self.rd.readline())
	    if not line: break
	    if line.startswith("#"):
		wrong = 1
	    if line.startswith("&"):
		wrong = 1
		suggestions = string.split(line[line.find(":")+2:], ", ")
	    if line.startswith(" "):
		hint += line
	if wrong:
	    return { 'suggestions': suggestions, 'hint': hint }
	else:
	    return {}


