#!/usr/bin/python

# This file is released under the terms of the GPL
# Copyright (C) Mooffie <mooffie@typo.co.il>

import sys
import cfg
import re
import socket
import thread
import proxyhandler
from errno import *

if not cfg.isp_proxy_addr:
    import os
    while not cfg.isp_proxy_addr:
	proxy_str = ""
	if os.environ.has_key('http_proxy'):
	    proxy_str = os.environ['http_proxy']
	if not proxy_str:
	    print "\nI have to know your ISP proxy address."
	    print "You should put it in 'cfg.py', but you may also type it now."
	    proxy_str = raw_input("Enter your ISP proxy address (or type ^C to quit): ")
	if ':' in proxy_str:
	    cfg.isp_proxy_addr, port = proxy_str.split(':')
	    cfg.isp_proxy_port = int(port)
	else:
	    cfg.isp_proxy_addr = proxy_str

cfg.allowed_hosts = map(lambda r: re.compile(r), cfg.allowed_hosts)

# Establish a server socket,
srv = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
try:
    srv.bind(('', cfg.service_port))
except socket.error, (errno, strerror):
    if errno == EADDRINUSE:
	print "Port " + `cfg.service_port` + " is already in use."
	print "If you've just terminated a previous instance of Proxpeller,"
	print "you may have to wait several seconds before starting a new one."
	sys.exit()
srv.listen(3)

print "Listening on port %i..." % cfg.service_port

# And for each incomming connection start a new thread
# to handle the request.

def handle_conn(conn):
    f = conn.makefile("r+")
    conn.close()
    hndlr = proxyhandler.ProxyHandler(f, f)
    try:
	hndlr.do()
    except IOError, (errno, strerror):
	if errno == EPIPE:
	    # "Broken pipe",
	    # user probably aborted the page loading,
	    # so we ignore this error.
	    pass
	else:
	    raise
    f.close()

while 1:
    conn, addr = srv.accept()
    if not filter(lambda r: r.search(addr[0]), cfg.allowed_hosts):
	print "WARNING: %s is not allowed to connect" % addr[0]
	conn.send("HTTP/1.1 403 Forbidden\n\n[Proxpeller] You are not allowed to connect here")
	conn.close()
    else:
	thread.start_new_thread(handle_conn, (conn,))

